function init(hero) {
    hero.setName("FiskTag");
    hero.setTier(1);
    hero.hide();
    
	hero.setHelmet("Goggles");
    hero.setChestplate("Vest");
	hero.setLeggings("Knee Pads");
    hero.addEquipment("fiskheroes:rip_hunters_gun");
	hero.addEquipment("fiskheroes:chronos_rifle");
    
    hero.addPowers("fiskheroes:retractable_blade");
    hero.addAttribute("FALL_RESISTANCE", 3.0, 0);
    hero.addAttribute("SPRINT_SPEED", 0.2, 1);
    
    hero.addKeyBind("AIM", "key.aim", -1);
    hero.addKeyBind("BLADE", "key.blade", 1);
    
    hero.addAttributeProfile("BLADE", bladeProfile);
    hero.setAttributeProfile(getAttributeProfile);
    hero.setKeyBindEnabled(isKeyBindEnabled);
    hero.setRuleValueModifier(ruleModifier);
    hero.setHasPermission(hasPermission);
    hero.setTierOverride(getTierOverride);
    hero.supplyFunction("canAim", canAim);
}

function getTierOverride(entity) {
    return entity.getData("fiskheroes:blade") ? 0 : 1;
}

function bladeProfile(profile) {
    profile.addAttribute("PUNCH_DAMAGE", 42069.0, 0);
    profile.addAttribute("FALL_RESISTANCE", 3.0, 0);
    profile.addAttribute("SPRINT_SPEED", 0.2, 1);
}

function getAttributeProfile(entity) {
    return entity.getData("fiskheroes:blade") ? "BLADE" : null;
}

function isKeyBindEnabled(entity, keyBind) {
    return keyBind != "BLADE" || entity.getHeldItem().isEmpty();
}

function ruleModifier(entity, rule) {
    switch (rule.name()) {
    case "fiskheroes:dmg_laserbolt":
        return 44 / 6;
    case "fiskheroes:dmg_fireball":
        return 200 / 6;
    case "fiskheroes:dmg_sonicwave":
        return 88 / 7;
    default:
        return null;
    }
}

function hasPermission(entity, permission) {
    return permission == "USE_RIPS_GUN" || permission == "USE_CHRONOS_RIFLE";
}

function canAim(entity) {
    return entity.getHeldItem().name() == "fiskheroes:rip_hunters_gun" || entity.getHeldItem().name() == "fiskheroes:chronos_rifle";
}
